(*
	IV окружной этап Всероссийской олимпиады школьников по информатике
	24 - 28 марта 2006 г.
	г. Петрозаводск

	Задача F. Студенческие годы Пекки
	Авторы: А. Лопатин, В. Кузнецов
	Решение: И. Николаевский
*)


program TheNProblem;

{$APPTYPE CONSOLE}
{$q+,R+,s+}
uses
  SysUtils;

const MAXHS=65536+65536;
const coef:array[1..10] of longint=(13,41,35,17,77,69,59,91,87,21);
const xx=43;


type spis=record
  fst:array[1..100000]of longint;
  nxt:array[1..100000]of longint;
end;
type arr=array[1..100000] of longint;
type wrd=array[1..10] of char;




var a,b:arr;
    tmp:arr;
    n,count:longint;
    sa,sb:spis;

var ht:array[0..MAXHS-1] of longint;
    hnxt:array[1..100000] of longint;
    Hval:array[1..100000] of wrd;

procedure gensps(var a:arr;var s:spis);
var i:longint;
begin
  fillchar(tmp,sizeof(tmp),0);
  for i:= 1 to n do begin
    if tmp[a[i]]=0 then begin
      s.fst[a[i]]:=i;
    end else s.nxt[tmp[a[i]]]:=i;
    tmp[a[i]]:=i;
  end;
end;



function getword(var w:wrd):char;
var c:char;
    i:longint;
begin
  read(c);
  i:=0;
  while not(c in [' ',#10,#13,#26]) do begin
    inc(i);
    w[i]:=c;
    read(c);
  end;
  for i:= i+1 to 10 do w[i]:=#0;
  getword:=c;
end;

function gethash(var w:wrd):longint;
var h,i:longint;
begin
  h:=0;
  for i:= 10 downto 1 do begin
    h:=h*xx mod MAXHS+(coef[i]*ord(w[i])) mod MAXHS
  end;
  h:=h mod MAXHS;
  gethash:=h;
end;


function add(hs:longint;w:wrd):longint;
var i,j:longint;
begin
  i:=ht[hs];
  j:=0;
  while i>0 do begin
    if Hval[i]=w then begin
      j:=i;
      break;
    end;
    i:=Hnxt[i];
  end;
  if j=0 then begin
    inc(count);
    j:=count;
    Hval[j]:=w;
    Hnxt[j]:=Ht[hs];
    Ht[hs]:=j;
  end;
  add:=j;
end;


procedure load;
var j,i:longint;
    w:wrd;
begin
  readln(n);
  count:=0;
  for i:= 1 to n do begin
    getword(w);
    j:=GetHash(w);
    a[i]:=Add(j,w);
    readln;
  end;
  for i:= 1 to n do begin
    getword(w);
    j:=GetHash(w);
    b[i]:=Add(j,w);
    readln;
  end;
  gensps(a,sa);
  gensps(b,sb);
end;

procedure solve;
var i,g,h:longint;
    l,r:longint;
begin
  l:=0;r:=0;
  for i:= 1 to count do begin
    g:=sa.fst[i];
    h:=sb.fst[i];
    while g>0 do begin
      assert(h>0);
      if (g-h>r) then r:=g-h;
      if (g-h<l) then l:=g-h;
      g:=sa.nxt[g];
      h:=sb.nxt[h];
    end;
  end;
  if -l>r then g:=(r+r-l)
  else g:=(r-l-l);
  write(g);
end;



begin
  assign(input,'train.in');
  assign(output,'train.out');
  reset(input);
  rewrite(output);
  load;
  solve;
  close(input);
  close(output);
end.
